import {Bus} from "./global";
import { EventEmitter } from "events";

export class InMemoryBus implements Bus{
    private emitter: EventEmitter;



    constructor(){
        this.emitter = new EventEmitter()
    }

    async command(commandName: string, payload: any): Promise<void> {
        this.emitter.emit(commandName,payload)
    }

    async listen(commandName: string, callback: (payload: any) => Promise<void>) {

        this.emitter = this.emitter.removeAllListeners(commandName);
        this.emitter.on(commandName, payload =>{
            callback(payload);
        })
    }

    on(eventName: string, callback: (payload: any) => Promise<void>) {
        this.emitter.on(eventName, callback)
    }

    async publish(eventName: string, payload: any): Promise<void> {
        this.emitter.emit(eventName, payload);
    }

}