"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var amqplib_1 = require("amqplib");
var RabbitMqBus = /** @class */ (function () {
    function RabbitMqBus(_a) {
        var url = _a.url;
        this.connection = amqplib_1.connect(url);
    }
    RabbitMqBus.prototype.channel = function (commandName) {
        return __awaiter(this, void 0, void 0, function () {
            var conn, ch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.connection];
                    case 1:
                        conn = _a.sent();
                        return [4 /*yield*/, conn.createChannel()];
                    case 2:
                        ch = _a.sent();
                        return [4 /*yield*/, ch.assertQueue(commandName)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, ch];
                }
            });
        });
    };
    RabbitMqBus.prototype.command = function (commandName, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var ch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.channel(commandName)];
                    case 1:
                        ch = _a.sent();
                        ch.sendToQueue(commandName, Buffer.from(JSON.stringify(payload)));
                        return [4 /*yield*/, ch.close()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RabbitMqBus.prototype.listen = function (commandName, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var ch;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.channel(commandName)];
                    case 1:
                        ch = _a.sent();
                        return [4 /*yield*/, ch.consume(commandName, function (msg) { return __awaiter(_this, void 0, void 0, function () {
                                var payload;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            if (!(msg !== null)) return [3 /*break*/, 2];
                                            ch.ack(msg);
                                            payload = JSON.parse(msg.content.toString());
                                            return [4 /*yield*/, callback(payload)];
                                        case 1:
                                            _a.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            ch.reject(msg);
                                            _a.label = 3;
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RabbitMqBus.prototype.publish = function (eventName, payload) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, ch, ok;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.exchange(eventName)];
                    case 1:
                        _a = _b.sent(), ch = _a.ch, ok = _a.ok;
                        ch.publish(eventName, '', Buffer.from(JSON.stringify(payload)));
                        return [4 /*yield*/, ch.close()];
                    case 2:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RabbitMqBus.prototype.on = function (eventName, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, ch, ok, queue;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.exchange(eventName)];
                    case 1:
                        _a = _b.sent(), ch = _a.ch, ok = _a.ok;
                        return [4 /*yield*/, ch.assertQueue('')];
                    case 2:
                        queue = (_b.sent()).queue;
                        return [4 /*yield*/, ch.bindQueue(queue, eventName, '')];
                    case 3:
                        _b.sent();
                        return [4 /*yield*/, ch.consume(queue, function (msg) { return __awaiter(_this, void 0, void 0, function () {
                                var payload;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            payload = JSON.parse(msg.content.toString());
                                            return [4 /*yield*/, callback(payload)];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); }, { noAck: true })];
                    case 4:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RabbitMqBus.prototype.exchange = function (eventName) {
        return __awaiter(this, void 0, void 0, function () {
            var conn, ch, ok;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.connection];
                    case 1:
                        conn = _a.sent();
                        return [4 /*yield*/, conn.createChannel()];
                    case 2:
                        ch = _a.sent();
                        return [4 /*yield*/, ch.assertExchange(eventName, 'fanout', { durable: false })];
                    case 3:
                        ok = _a.sent();
                        return [2 /*return*/, { ch: ch, ok: ok }];
                }
            });
        });
    };
    return RabbitMqBus;
}());
exports.RabbitMqBus = RabbitMqBus;
